module win32.tchar;
import win32.windef;
import win32.winbase;
import std.utf;

version(Unicode)
{
    const(TCHAR)* _T( wstring str ) { return (str~\0).ptr; }

     string TtoC( invariant(TCHAR)* tc ) { return TtoW(tc).toUTF8(); }
    wstring TtoW( invariant(TCHAR)* tc ) { return tc[0..lstrlen(cast(TCHAR*)tc)]; }
}
else
{
    import std.windows.charset;
    const(TCHAR)* _T( string str ) { return str.toMBSz(); }

     string TtoC( invariant(TCHAR)* tc ) { return fromMBSz(tc); }
    wstring TtoW( invariant(TCHAR)* tc ) { return fromMBSz(tc).toUTF16(); }
}
